global gOL -- GLOBAL OBJECT LIST

--**************************************
-- SYSTEM EVENT HANDLERS
--**************************************

----------------------------------------
--
----------------------------------------
on prepareMovie
    
  --_movie.idleHandlerPeriod = 180 -- 3 sec
  
  -- PREFS
  gOL = [:]
  
  gOL["fullscreen"] = 0
  gOL["filename"] = ""
  gOL["palette"] = []
  gOL["resizeFlag"] = 0
  gOL["zoom"] = 1.0

  settings = iniToPropList(the moviepath&"viewer.ini")
  if voidP(settings["options"]) then settings["options"]=[:]
  gOL["options"] = settings["options"]
  
  -- FILE FORMATS
  gOL["formats"] = [:]
  gOL["formats"]["read"] = [:]
  gOL["formats"]["write"] = [:]
  
  formats = settings["formats"]
  cnt = count(formats)
  repeat with i = 1 to cnt
    prop = string(formats.getPropAt(i))
    tmp = explode(",", formats[i])
    
    types = explode("|", tmp[2])
    flags = tmp[3]
    s = ""
    repeat with t in types
      put "*."&t&";" after s
    end repeat
    delete the last char of s
    fmask = tmp[1] && "("&s&"),"&s
    f = ["title":tmp[1], "mask": fmask, "types": types, "flags":flags]
    if flags.char[1] = "1" then -- READ
      gOL["formats"]["read"][prop] = f
    end if
    if flags.char[2] = "1" then -- WRITE
      gOL["formats"]["write"][prop] = f
    end if
  end repeat  
  
  -- PLUGINS ???
  -- f = ["title":"PDF File", "mask": "PDF File (*.pdf),*.pdf", "types": ["pdf"], "flags":""]
  -- gOL["formats"]["write"]["PDF"] = f
    
  -- MANAGER OBJECTS
  gOL["MENU_MGR"] = script("MENU_CLASS") -- singleton, no instance
  if not (the runmode contains "author") then mCreateMenu()
  	
  gOL["IMAGE_MGR"] = script("IMAGE_CLASS") -- singleton, no instance
  gOL["IMAGE_MGR"].mInit()

  -- CREATE TOOLBAR
  gOL["TOOLBAR_MGR"] = script("TOOLBAR_CLASS") -- singleton, no instance
  tbImg = gOL["IMAGE_MGR"].mLoadImage(_movie.path&"toolbars\"&gOL["options"]["toolbar"])	
  tbButtonFlags = gOL["options"]["toolbarButtons"]
  if voidP(tbButtonFlags) then tbButtonFlags="1,1,1,1,1,1,|,1,1,1,1,|,1,1,1,1,1,1,1,|,1,1"
  tbButtonFlags = explode(",", tbButtonFlags)
  tbCallbacks = [#mOpenFile,#empty,#empty,#mSaveFileAs,#mPrint,#empty,#sep,#empty,#mCopy,#mPaste,#mUndo,#sep,#mInfo,#mZoomIn,#mZoomOut,#mPreviousImage,#mNextImage,#mPreviousPage,#mNextPage,#sep,#empty,#mAbout]
  gOL["TOOLBAR_MGR"].mInit(tbImg, tbButtonFlags, tbCallbacks)

end

----------------------------------------
--
----------------------------------------
on startMovie
  startDropFile()
  l = parseCommandLine()
  if count(l) then
  	fn = l[1]
  	if getFileType(fn)<>"DML" then
  		gOL["IMAGE_MGR"].mOpenFile(fn)
  	end if
  end if
end

----------------------------------------
--
----------------------------------------
on stopMovie
  _movie.actorlist=[]
  
  if (the runmode contains "author") then
    member("img").image = image(1,1,24)
    
  else
    closeDropFile()
  end if
end

----------------------------------------
--
----------------------------------------
on resizeWindow
	if voidP(gOL) then return
	if gOL["filename"]<>"" AND gOL["fullscreen"]=0 then
		gOL["resizeFlag"] = 1
	end if
end

----------------------------------------
--
----------------------------------------
on zoomWindow
   gOL["IMAGE_MGR"].mResizeImage()
end

----------------------------------------
-- 
----------------------------------------
on idle
	if gOL["resizeFlag"] then
		gOL["IMAGE_MGR"].mResizeImage()
		gOL["resizeFlag"]=0
	end if
end

----------------------------------------
-- 
----------------------------------------
on keyDown
	-- put _key.keyCode
		
	case (_key.keyCode) of
		3:  -- F
			if _key.controlDown then mToggleFullscreen()
		31: -- O
			if _key.controlDown then mOpenFile()
		1:  -- S
			if _key.controlDown then mSaveFile()
		13: -- W
			if _key.controlDown then mClose()
		35: -- P
			if _key.controlDown then mPrint()
				
		8:  -- C
			if _key.controlDown then mCopy()
		9:  -- V
			if _key.controlDown then mPaste()
		34: -- I
			if _key.controlDown then mAbout()
					
		-- 122: -- F1
		
		123, 51: -- ->, SPACE
			mPreviousImage()
		124, 49: -- <-, BACKSPACE
			mNextImage()
			
		24: -- +
			mZoomIn()
		27: -- -
			mZoomOut()
		36: -- RETURN
			mToggleFullscreen()
	end case
		
end

----------------------------------------
-- 
----------------------------------------
on mouseUp
	if _mouse.doubleClick then mToggleFullscreen()
end

--**************************************
-- CUSTOM CALLBACKS
--**************************************

----------------------------------------
--
----------------------------------------
on dropFile
  fileList = getDroppedFiles()
  gOL["IMAGE_MGR"].mOpenFile( fileList[1] )
end

----------------------------------------
--
----------------------------------------
on scanCallback (img, b)
  if ilk(img)=#image then
  	gOL["palette"] = []
		member("img").image = img
		gOL["filename"] = "scan"
		gOL["zoom"] = 1.0
		gOL["IMAGE_MGR"].mResizeImage()
		mUpdateMenu()
  end if
end

----------------------------------------
--
----------------------------------------
on mCreateMenu
  
  m = gOL["MENU_MGR"]
  m.mInit()
  
  -- "checkMark":0, "enabled":1
  
  -- FILE
  m.mAddMenu ("File")
  m.mAddItem ("File",  ["name": "Open", "letter":"O", "handler":"mOpenFile()"])
  
  m.mAddItem ("File",  ["name": "Save", "letter":"S", "handler":"mSaveFile()"])
  --m.mAddItem ("File",  ["name": "Save as...", "handler":"mSaveFileAs()"])
    
  m.mAddItem ("File",  ["name": "Close", "letter":"W", "handler":"mClose()"])
  m.mAddSep  ("File")
  m.mAddItem ("File",  ["name": "Print", "letter":"P", "handler":"mPrint()"])
  
  --m.mAddSep  ("File")
  --m.mAddItem ("File",  ["name": "Thumbnails", "letter":"T", "handler":"mBrowse()"])
  
  -- Slideshow ?
  -- Batch Conversion ?
  m.mAddSep  ("File")
  m.mAddItem ("File",  ["name": "Select TWAIN source...", "handler":"mSelectTwainSource()"])
  m.mAddItem ("File",  ["name": "Scan", "handler":"mScan()"])
  m.mAddSep  ("File")
  m.mAddItem ("File",  ["name": "Exit", "letter": "Q", "handler":"mQuit()"])
  
  
  -- EDIT
  m.mAddMenu ("Edit")
  m.mAddItem ("Edit",  ["name": "Undo", "letter":"Z", "handler":"mUndo()"])
  m.mAddSep  ("Edit")
  m.mAddItem ("Edit",  ["name": "Copy", "letter":"C", "handler":"mCopy()", "enabled":0])
  m.mAddItem ("Edit",  ["name": "Paste", "letter":"V", "handler":"mPaste()", "enabled":1])
  m.mAddSep  ("Edit")
  m.mAddItem ("Edit",  ["name": "Crop", "handler":"mCrop()", "enabled":0])
  --m.mAddSep  ("Edit")
  --m.mAddItem ("Edit",  ["name": "Paint", "handler":"mPaint()"])
  
  
  -- IMAGE
  m.mAddMenu ("Image")
  m.mAddItem ("Image",  ["name": "Information", "letter":"I", "handler":"mInfo()", "enabled":0])
  m.mAddSep  ("Image")
  m.mAddItem ("Image",  ["name": "Rotate",  "handler":"mRotate()", "enabled":0])
  m.mAddSep  ("Image")
  m.mAddItem ("Image",  ["name": "Vertical Flip",  "handler":"mVerticalFlip()", "enabled":0])
  m.mAddItem ("Image",  ["name": "Horizontal Flip",  "handler":"mHorizontalFlip()", "enabled":0])
  m.mAddSep  ("Image")
  m.mAddItem ("Image",  ["name": "Resize", "handler":"mResize()", "enabled":0])
  m.mAddSep  ("Image")
  m.mAddItem ("Image",  ["name": "Change Color Depth", "handler":"mChangeDepth()", "enabled":0])
  m.mAddItem ("Image",  ["name": "Invert", "handler":"mInvert()", "enabled":0])
  m.mAddItem ("Image",  ["name": "Adjust Colors", "handler":"mAdjustColors()", "enabled":0])
  m.mAddItem ("Image",  ["name": "Histogram...", "handler":"mHistogram()", "enabled":0])
  m.mAddSep  ("Image")
  m.mAddItem ("Image",  ["name": "Edit Palette", "handler":"mEditPalette()", "enabled":0])
  m.mAddItem ("Image",  ["name": "Export Palette", "handler":"mExportPalette()", "enabled":0])
  m.mAddItem ("Image",  ["name": "Import Palette", "handler":"mImportPalette()", "enabled":0])
  
  m.mAddSep  ("Image")
  m.mAddItem ("Image",  ["name": "JPG Lossless Crop", "handler":"mJpegCrop()", "enabled":0])
  m.mAddItem ("Image",  ["name": "JPG Lossless Horizontal flip", "handler":"mJpegTransform(1)", "enabled":0])
  m.mAddItem ("Image",  ["name": "JPG Lossless Vertical flip", "handler":"mJpegTransform(2)", "enabled":0])
  m.mAddItem ("Image",  ["name": "JPG Lossless 90 clockwise rotation", "handler":"mJpegTransform(5)", "enabled":0])
  m.mAddItem ("Image",  ["name": "JPG Lossless 180 clockwise rotation", "handler":"mJpegTransform(6)", "enabled":0])
  m.mAddItem ("Image",  ["name": "JPG Lossless 270 clockwise rotation", "handler":"mJpegTransform(7)", "enabled":0])
  
  
  -- PLUGINS
  m.mAddMenu ("Plugins")
	m.mAddItem ("Plugins",  ["name": "TO DO", "handler":"mPlugin(1)", "enabled":0])  
  
  
  -- VIEW
  m.mAddMenu ("View")
  m.mAddItem ("View",  ["name": "Zoom in", "handler":"mZoomIn()", "enabled":0]) -- "letter":"+"
  m.mAddItem ("View",  ["name": "Zoom out", "handler":"mZoomOut()", "enabled":0]) -- "letter":"-", 
  m.mAddItem ("View",  ["name": "Original size", "handler":"mOriginalSize()", "enabled":0])
  m.mAddSep  ("View")
  m.mAddItem ("View",  ["name": "Full screen", "letter":"F", "handler":"mFullScreen()", "enabled":0])
  m.mAddSep  ("View")
  m.mAddItem ("View",  ["name": "Previous image", "handler":"mPreviousImage()", "enabled":0])
  m.mAddItem ("View",  ["name": "Next image", "handler":"mNextImage()", "enabled":0])
  m.mAddSep  ("View")
  m.mAddItem ("View",  ["name": "Multipage image:", "enabled":0])
  m.mAddItem ("View",  ["name": "Next page", "handler":"mNextPage()", "enabled":0]) -- "letter":numtochar(29)
  m.mAddItem ("View",  ["name": "Previous page", "handler":"mPreviousPage()", "enabled":0]) -- "letter":numtochar(28)
  m.mAddItem ("View",  ["name": "Export current page", "handler":"mExportPage()", "enabled":0])
  --m.mAddSep  ("View")
  --m.mAddItem ("View",  ["name": "Hex view", "handler":"mHexView()"])
  
  
  -- HELP
 	m.mAddMenu ("Help")
  --m.mAddItem ("Help",  ["name": "Contents", "letter":"H", "handler":"mHelp()"])
  --m.mAddSep  ("Help")
  m.mAddItem ("Help",  ["name": "About ImgViewer...", "handler":"mAbout()"])
  
  m.mShow() 
  
end

----------------------------------------
-- 
----------------------------------------
on mToggleFullscreen
	if gOL["fullscreen"]=0 then

		gOL["MENU_MGR"].mHide()
		
		gOL["rect"] = _movie.stage.rect
		sprite("toolbar_bg").visible=0
		sprite("toolbar").visible=0
		sprite("line1").visible=0
		sprite("line2").visible=0
		sprite("line3").visible=0
		_movie.stage.titlebarOptions.visible = 0
	  r = _system.deskTopRectList[1]
		_movie.stage.rect = r

	else
		_movie.stage.rect = gOL["rect"]
		_movie.stage.titlebarOptions.visible = 1
		
		gOL["MENU_MGR"].mShow()
		gOL["IMAGE_MGR"].mResizeImage()

		sprite("toolbar_bg").visible=1
		sprite("toolbar").visible=1
		sprite("line1").visible=1
		sprite("line2").visible=1
		sprite("line3").visible=1
		
		startDropFile()
	end if
	gOL["fullscreen"] = not(gOL["fullscreen"])
end

----------------------------------------
--
----------------------------------------
on mUpdateMenu
	-- CLIPBOARD
	--	formatList = clipGetFormats()
	--	pasteFlag = formatList.getPos(8)
	--	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Edit", "Paste", pasteFlag)
	
	imgFlag = (gOL["filename"]<>"")
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Edit", "Copy", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Information", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Rotate", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Vertical Flip", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Horizontal Flip", imgFlag)
	
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Resize", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Change Color Depth", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Invert", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Adjust Colors", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Histogram...", imgFlag)
	
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("View", "Zoom in", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("View", "Zoom out", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("View", "Original size", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("View", "Full screen", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("View", "Previous image", imgFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("View", "Next image", imgFlag)
	
	-- JPG
	jpgFlag = (getFileType(gOL["filename"])="jpg")
 	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "JPG Lossless Crop", jpgFlag)
 	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "JPG Lossless Horizontal flip", jpgFlag)
 	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "JPG Lossless Vertical flip", jpgFlag)
 	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "JPG Lossless 90 clockwise rotation", jpgFlag)
 	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "JPG Lossless 180 clockwise rotation", jpgFlag)
 	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "JPG Lossless 270 clockwise rotation", jpgFlag)

	-- 8 Bit
	palFlag = (member("img").depth=8)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Edit Palette", palFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Export Palette", palFlag)
	gOL["MENU_MGR"].mSetItemEnabledEnabled ("Image", "Import Palette", palFlag)
	
end

----------------------------------------
--
----------------------------------------
on mForgetWindow (tTitle)
	if _player.windowPresent(tTitle) then 
		-- window(tTitle).close()
		aTimerObj = timeout().new(tTitle, 1, #_forgetWindow)
	end if
end

----------------------------------------
--
----------------------------------------
on _forgetWindow me, aTimer
	if _player.windowPresent(aTimer.name) then _player.window[aTimer.name].forget()
	aTimer.forget()
end
