global gOL

property pIX
property pMember

--property pPalette
--property pImage

----------------------------------------
-- 
----------------------------------------
on new me
	return me.script
end

----------------------------------------
-- 
----------------------------------------
on mInit me
	pIX = xtra("ImgXtra").new()
	pMember = member("img")
end

----------------------------------------
-- 
----------------------------------------
on mDestroy me
	pIX = 0
end

----------------------------------------
-- 
----------------------------------------
on mLoadImage (me, tFilename)
	return pIX.ix_loadImage(["filename":tFilename])
end

----------------------------------------
-- 
----------------------------------------
on mOpenFile (me, tFilename)
  gOL["filename"] = tFilename
  gOL["zoom"] = 1.0
  
  props = [:]
  props["filename"] = tFilename
  props["colors"] = []
  
  img = pIX.ix_loadImage(props)
  if ilk(img)=#image then
		
		-- colors falsch rum ?
		tColorList = props["colors"] -- empty if <> 8bit
  	reverseList = []
  	repeat with i = count(tColorList) down to 1
	  	reverseList.add(tColorList[i])
	  end repeat
		gOL["palette"] = tColorList
		
    pMember.image = img
    --pMember.regpoint = point(0,0)
    mResizeImage()
    mUpdateMenu() -- TEST
    
  end if
end

----------------------------------------
-- 
----------------------------------------
on mSaveFile (me, tFilename)
	if gOL["filename"]<>"" then
	  props = [:]
	  props["filename"] = tFilename
	  props["image"] = pMember.image
	  img = pIX.ix_saveImage(props)
	end if
end

----------------------------------------
-- 
----------------------------------------
on mResizeImage (me)
	gOL["zoom"] = 1.0 -- ???
  if not voidP(gOL) then
		if gOL["filename"]<>"" then
			
			pMember.regpoint = point(0,0)
			
	    sr = _movie.stage.rect
	    
	    w = pMember.width --* gOL["zoom"]
	    h = pMember.height --* gOL["zoom"]
	    
	    if w<sr.width AND h<sr.height then
	    	-- center
	    	x = sr.width/2-pMember.width/2
	    	y = sr.height/2-pMember.height/2
	    	r = rect(x, y,x+pMember.width,y+pMember.height)
	    	sprite("img").rect = r
	    else		        
				vr = rect(0, 0, sr.width, sr.height - 28)
				r = findMaxRect (vr, float(pMember.width)/pMember.height)
				sprite("img").rect = r.offset(0, 28)
			end if

  	end if
	end if
	updateStage()
end

----------------------------------------
-- 
----------------------------------------
on mPrintImage (me)
  if gOL["filename"]<>"" then
		tPageWidth = 595
		tPageHeight = 842
		
		f = 150.0 / 72
	
		img = pMember.image
	
		vr = rect(0, 0, tPageWidth, tPageHeight)
		r = findMaxRect (vr, float(pMember.width)/pMember.height)
		r = r.inflate(-20,-20)
		
		tImage = image(595*f, 842*f, 32)
		tImage.fill(tImage.rect, RGB(255,255,255))
		tImage.copyPixels(img, r*f, img.rect)
		tImage.draw(r*f, [#shapeType:#rect, #lineSize:1, #color:RGB(0,0,0)])
		
	  s = sprite("flash")
	
	  myBitmapData = s.convert(#BitmapData, tImage)
	
	  s.createEmptyMovieClip("image_mc", 1)
	  s.image_mc.attachBitmap(myBitmapData, 1)
	
	  s.image_mc._width = tPageWidth
	  s.image_mc._height = tPageHeight
	
	  printArea = s.newObject("Object")
	  printArea.xMin = 0
	  printArea.xMax = tPageWidth*f
	  printArea.yMin = 0
	  printArea.yMax = tPageHeight*f
	
	  options = s.newObject("Object")
	  options.printAsBitmap = 1
	
	  myPrintJob = s.newObject("PrintJob")
	  res = myPrintJob.start()
	  myPrintJob.addPage("image_mc", printArea, options, 1)
	  myPrintJob.send()
	  myPrintJob = VOID
	
	  myBitmapData.dispose()
	  s.image_mc.removeMovieClip()
	end if
end

----------------------------------------
-- 
----------------------------------------
on mCopyClipboard (me)
	if gOL["filename"]<>"" then
		--pMember.copyToClipBoard()
		props = [:]
  	props["format"] = "BMP"
  	props["image"] = pMember.image
  	data = pIX.ix_saveMemoryImage(props)
		data = getDibFromBmp(data)
		clipSetData(8, data) -- or 2, ...
	end if
end

----------------------------------------
-- 
----------------------------------------
on mPasteClipboard (me)

	--2  CF_BITMAP
	--3  CF_METAFILEPICT
	--6  CF_TIFF
	--8  CF_DIB
	--9  CF_PALETTE
	--12 CF_WAVE
	--14 CF_ENHMETAFILE
	--17 CF_DIBV5

	-- put clipGetFormats()

	data = clipGetData(8) -- or 2, ...
	
	if not voidP(data) then
		
		data = getBmpFromDib(data)
  	props = [:]
  	props["format"] = "BMP"
  	props["data"] = data
  	props["colors"] = []
  	img = pIX.ix_loadMemoryImage(props)
  	
    if ilk(img)=#image then
    	gOL["palette"] = props["colors"]
      pMember.image = img
      gOL["filename"] = "clipboard"
      gOL["zoom"] = 1.0
      mResizeImage()
      mUpdateMenu()
		end if

	end if
end

----------------------------------------
-- 
----------------------------------------
on mExportPalette (me, fn)
  if gOL["filename"]<>"" then		
	  data = ""
	  colList = gOL["palette"]
	  cnt = count(colList)
	  
	  if getFileType(fn)="PAL" then
	  	
	  	 -- JASC-PAL
		  r = numtochar(13)&numtochar(10)
		  put "JASC-PAL"&r after data
		  put dec2hex(cnt)&r after data
			put cnt&r after data
			repeat with c in colList
				put c.red && c.green && c.blue &r after data
			end repeat
		else
			
		  -- ACT
		  black = numToChar(0)&numToChar(0)&numToChar(0)
		  repeat with i = 1 to cnt
		    c = colList[i]
		    put numtochar(c.red) after data
		    put numtochar(c.green) after data
		    put numtochar(c.blue) after data
		  end repeat
		  repeat with i = cnt+1 to 256
		    put black after data
		  end repeat
	  end if
	
	  ok = file_put_contents(fn, data)
	end if
end

----------------------------------------
-- 
----------------------------------------
on mImportPalette (me, fn)
	data = file_get_contents(fn)
	if data<>"" then
		tColorList = []
	  if getFileType(fn)="PAL" then
	  	
			-- JASC-PAL
			tColors = explode(numtochar(13)&numtochar(10), data)
			cnt = min(259,count(tColors))
			repeat with i = 4 to cnt
				r = integer(tColors[i].word[1])
				g = integer(tColors[i].word[2])
				b = integer(tColors[i].word[3])
				tColorList.add(RGB(r,g,b))
			end repeat
	  	 
		else
		
	  	-- ACT
			repeat with i = 0 to 255
				r = chartonum(data.char[i*3 + 1])
				g = chartonum(data.char[i*3 + 2])
				b = chartonum(data.char[i*3 + 3])
				tColorList.add(RGB(r,g,b))
			end repeat
			
		end if
		
		if count(tColorList) then
			
			palRef = pMember.paletteRef
			
		  -- reverse list (why ???)
	  	reverseList = []
	  	cnt =  count(tColorList)
	  	repeat with i = cnt down to 1
		  	reverseList.add(tColorList[i])
		  end repeat
						
			-- A): change palette mem
			props = [:]
			props["palette"] = palRef
			props["colors"] = reverseList
			
			pIX.ix_setPaletteColors(props)
			
			pMember.paletteRef=pMember.paletteRef
			
			gOL["palette"] = tColorList

		end if
	end if
end

----------------------------------------
--
----------------------------------------
--on mGetPalette me
--	return pPalette
--end

----------------------------------------
--
----------------------------------------
on mSelectTwainSource me
  pIX.ix_twainSelectSource()
end

----------------------------------------
--
----------------------------------------
on mScan
	props = ["callback": #scanCallback]
	pIX.ix_twainSetCallback(props)
	props = ["dialog":1]
  ok = pIX.ix_twainAcquireImage(props)
end

----------------------------------------
--
----------------------------------------
on mInfo
  if gOL["filename"]<>"" then
    props = [:]
    
    if gOL["filename"]="clipboard" OR gOL["filename"]="scan" then
    	str = ""
    	
    	put "width:" && pMember.width &RETURN after str
    	put "height:" && pMember.height &RETURN after str
    	put "bitsPerPixel:" && pMember.depth &RETURN after str
    	
		else
    
	    props["filename"] = gOL["filename"]
	
	    props["general"] = 1
	    props["exif"] = 1
	    --props["thumbnail"] = 1
	    --props["transparency"] = 1
	      
	    info = pIX.ix_getInfo(props)
	    str = ""
	    cnt = count(info)
	    repeat with i = 1 to cnt
	      put string(info.getPropAt(i))&": "&info[i] &RETURN after str
	    end repeat
    
    end if
    alert(str)
  end if
end

----------------------------------------
--
----------------------------------------
on mRotate me
	if gOL["filename"]<>"" then

		props = [:]
		props["image"] = pMember.image
		props["angle"] = -90
		pMember.image = pIX.ix_rotate(props)
		pMember.regPoint = point(0,0)
		mResizeImage()
		
  end if
end

----------------------------------------
--
----------------------------------------
on mVerticalFlip me
  if gOL["filename"]<>"" then
		props = [:]
		props["image"] = pMember.image
		img = pIX.ix_flipVertical(props)
		if ilk(img)=#image then
			pMember.image = img
			pMember.regPoint = point(0,0)
			mResizeImage()
		end if
  end if
end

----------------------------------------
--
----------------------------------------
on mHorizontalFlip me
  if gOL["filename"]<>"" then
		props = [:]
		props["image"] = pMember.image
		img = pIX.ix_flipHorizontal(props)
		if ilk(img)=#image then
			pMember.image = img
			pMember.regPoint = point(0,0)
			me.mResizeImage()
		end if
  end if
end

----------------------------------------
--
----------------------------------------
on mInvert me
	if gOL["filename"]<>"" then
		props = ["image": pMember.image]
	  ok = pIX.ix_invert(props) -- BUG: creates alpha chanel!
	  if ok then			
	  	me.mResizeImage()
	  end if
	end if
end

----------------------------------------
--
----------------------------------------
on mSetPalette (me, tColorList)
	if gOL["filename"]<>"" AND count(gOL["palette"]) then
		palRef = pMember.paletteRef

	  -- reverse list (why ???)
  	reverseList = []
  	repeat with i = count(tColorList) down to 1
	  	reverseList.add(tColorList[i])
	  end repeat

  	props = [:]
  	props["image"] = pMember.image
  	props["format"] = "GIF"
  	props["palette"] = reverseList
  	
  	data = pIX.ix_saveMemoryImage(props)
  	  	
  	props = [:]
  	props["data"] = data
  	props["colors"] = []
  	img = pIX.ix_loadMemoryImage(props)
  	
  	oldPal = pMember.paletteRef
  	if ilk(img)=#image then

  		--gOL["palette"] = props["colors"]
  		pMember.image = img
  		pMember.regpoint = point(0,0)
  		--pMember.paletteRef = img.paletteRef
  		if ilk(oldPal)=#member then oldPal.erase()
  		gOL["palette"] = tColorList
  	else
  		put img
  	end if
  end if
end

----------------------------------------
-- tChannel: 1=R, 2=G, 3=B or 5=Use"Black Channel"=default. 
-- For 8-bit images the channel parameter is ignored.
----------------------------------------
on mGetHistogram (me, tChannel)
	if voidP(tChannel) then tChannel = 5
	props = [:]
	props["image"] = pMember.image
	props["channel"] = tChannel
	histo = pIX.ix_getHistogramm(props)	
	return histo
end

----------------------------------------
--
----------------------------------------
on mJpegCrop me
	if gOL["filename"]<>"" AND getFileType(gOL["filename"])="jpg" then
		props = [:]
		props["src_filename"] = gOL["filename"]
		props["dest_filename"] = getFolder(gOL["filename"]) & getFileName(gOL["filename"]) & "_cropped.jpg"
		props["left"] = 0
		props["top"] = 0
		props["right"] = 500
		props["bottom"] = 500
		ok = pIX.ix_jpegCrop(props)
		if ok then
			me.mOpenFile (props["dest_filename"])
		end if
	end if
end

----------------------------------------
--
----------------------------------------
on mJpegTransform (me, n)
	if gOL["filename"]<>"" AND getFileType(gOL["filename"])="jpg" then
		props = [:]
		props["src_filename"] = gOL["filename"]
		props["dest_filename"] = gOL["filename"]
		props["operation"] = n
		--props["perfect"] = 1
		ok = pIX.ix_jpegTransform(props)
		if ok then
			me.mOpenFile (props["dest_filename"])
		end if
	end if
end