global gOL

--**************************************
-- FILE
--**************************************

----------------------------------------
--
----------------------------------------
on mOpenFile
  fmask = "All Files (*.*),*.*"
  allTypes = ""
  repeat with f in gOL["formats"]["read"]
    put ","&f["mask"] after fmask
    put "*."& implode(";*", f["types"])&";" after allTypes
  end repeat
  delete the last char of allTypes

  put "All Supported Formats,"&allTypes&"," before fmask

  fn = display_open ("Open File", fmask, "")
  if fn<>"" then gOL["IMAGE_MGR"].mOpenFile(fn)
end

----------------------------------------
--
----------------------------------------
on mSaveFile
	-- TO DO: use current name and format as defaults in save dialog	
	mSaveFileAs()
end

----------------------------------------
--
----------------------------------------
on mSaveFileAs
  if gOL["filename"]<>"" then
	  fmask = ""
	  repeat with f in gOL["formats"]["write"]
	    put f["mask"]&"," after fmask
	  end repeat
	  delete the last char of fmask

		default = getFileName(gOL["filename"])
		
	  fn = display_save ("Save File as...", fmask, default)
	  if fn<>"" then gOL["IMAGE_MGR"].mSaveFile(fn)
	end if
end

----------------------------------------
--
----------------------------------------
on mClose
	sprite("img").width=0
	sprite("img").height=0
	member("img").image = image(1,1,24)
  gOL["filename"] = ""
  mUpdateMenu()
end

----------------------------------------
--
----------------------------------------
on mPrint
	gOL["IMAGE_MGR"].mPrintImage()
end

----------------------------------------
--
----------------------------------------
--on mBrowse
--  --
--end

----------------------------------------
--
----------------------------------------
on mSelectTwainSource
  gOL["IMAGE_MGR"].mSelectTwainSource()
end

----------------------------------------
--
----------------------------------------
on mScan
	gOL["IMAGE_MGR"].mScan()
end

----------------------------------------
--
----------------------------------------
on mQuit
  halt()
end

--**************************************
-- EDIT
--**************************************

----------------------------------------
--
----------------------------------------
on mUndo()
  alert("TO DO")
end

----------------------------------------
--
----------------------------------------
on mCopy
  gOL["IMAGE_MGR"].mCopyClipboard()
end

----------------------------------------
--
----------------------------------------
on mPaste
	gOL["IMAGE_MGR"].mPasteClipboard()
end

----------------------------------------
--
----------------------------------------
on mCrop
  alert("TO DO")
end

----------------------------------------
--
----------------------------------------
--on mPaint
--  --
--end

--**************************************
-- IMAGE
--**************************************

----------------------------------------
--
----------------------------------------
on mInfo
	gOL["IMAGE_MGR"].mInfo()
end

----------------------------------------
--
----------------------------------------
on mRotate
	gOL["IMAGE_MGR"].mRotate()
end

----------------------------------------
--
----------------------------------------
on mVerticalFlip
	gOL["IMAGE_MGR"].mVerticalFlip()
end

----------------------------------------
--
----------------------------------------
on mHorizontalFlip
	gOL["IMAGE_MGR"].mHorizontalFlip()
end

----------------------------------------
--
----------------------------------------
on mResize
  alert("TO DO")
end

----------------------------------------
--
----------------------------------------
on mChangeDepth
  alert("TO DO")
end

----------------------------------------
--
----------------------------------------
on mInvert
	gOL["IMAGE_MGR"].mInvert()
end

----------------------------------------
--
----------------------------------------
on mAdjustColors
  alert("TO DO")
end

----------------------------------------
--
----------------------------------------
on mHistogram
	win = window().new("histogram")
	win.filename = "miaw\histogram"
	win.open()
end

----------------------------------------
--
----------------------------------------
on mEditPalette
  if gOL["filename"]<>"" AND count(gOL["palette"]) then
		pal = window().new("palette")
		pal.filename = "miaw\palette"
		pal.open()
  end if
end

----------------------------------------
--
----------------------------------------
on mSetPalette (tColorList)
	gOL["IMAGE_MGR"].mSetPalette(tColorList)
end

----------------------------------------
--
----------------------------------------
on mGetPalette
	return gOL["IMAGE_MGR"].mGetPalette()
end

----------------------------------------
--
----------------------------------------
on mGetHistogram (tChannel)
	return gOL["IMAGE_MGR"].mGetHistogram(tChannel)
end

----------------------------------------
--
----------------------------------------
on mExportPalette
  if gOL["filename"]<>"" then
	  fn = display_save ("Save Palette as...", "ACT file (*.act),*.act,PAL file (*.pal),*.pal", "palette")
	  if fn<>"" then gOL["IMAGE_MGR"].mExportPalette(fn)
	end if
end

----------------------------------------
--
----------------------------------------
on mImportPalette
	fn = display_open ("Open Palette File...", "ACT file (*.act),*.act,PAL file (*.pal),*.pal", "")
	if fn<>"" then importPalette(fn)
end

----------------------------------------
--
----------------------------------------
on mJpegCrop
	gOL["IMAGE_MGR"].mJpegCrop()
--	if gOL["filename"]<>"" AND getFileType(gOL["filename"])="jpg" then
--		props = [:]
--		props["src_filename"] = gOL["filename"]
--		props["dest_filename"] = getFolder(gOL["filename"]) & getFileName(gOL["filename"]) & "_cropped.jpg"
--		props["left"] = 0
--		props["top"] = 0
--		props["right"] = 200
--		props["bottom"] = 200
--		ok = gIX.ix_jpegCrop(props)
--		if ok then
--			openFile (props["dest_filename"])
--		end if
--	end if
end

----------------------------------------
--
----------------------------------------
on mJpegTransform (n)
	gOL["IMAGE_MGR"].mJpegTransform(n)
--	if gOL["filename"]<>"" AND getFileType(gOL["filename"])="jpg" then
--		props = [:]
--		props["src_filename"] = gOL["filename"]
--		props["dest_filename"] = gOL["filename"]
--		props["operation"] = n
--		--props["perfect"] = 1
--		ok = gIX.ix_jpegTransform(props)
--		if ok then
--			openFile (props["dest_filename"])
--		end if
--	end if
end

--**************************************
-- FILTERS
--**************************************

----------------------------------------
--
----------------------------------------
on mFilter (n)
  alert("TO DO")
end

--**************************************
-- VIEW
--**************************************

----------------------------------------
--
----------------------------------------
on mZoomIn
	if gOL["filename"]<>"" then
		gOL["zoom"] = gOL["zoom"] * 1.2
		
		w = member("img").width * gOL["zoom"]
		h = member("img").height * gOL["zoom"]
		
		-- center
		sr = _movie.stage.rect
		x = sr.width/2-w/2
		y = sr.height/2-h/2
		r = rect(x, y,x+w,y+h)
		sprite("img").rect = r
	end if
end

----------------------------------------
--
----------------------------------------
on mZoomOut
	if gOL["filename"]<>"" then
	  gOL["zoom"] = gOL["zoom"] / 1.2
	  
		w = member("img").width * gOL["zoom"]
		h = member("img").height * gOL["zoom"]
		
		-- center
		sr = _movie.stage.rect
		x = sr.width/2-w/2
		y = sr.height/2-h/2
		r = rect(x, y,x+w,y+h)
		sprite("img").rect = r
	end if
end

----------------------------------------
--
----------------------------------------
on mOriginalSize
	gOL["zoom"] = 1.0
	
	w = member("img").width * gOL["zoom"]
	h = member("img").height * gOL["zoom"]
	
	-- center
	sr = _movie.stage.rect
	x = sr.width/2-w/2
	y = sr.height/2-h/2
	r = rect(x, y,x+w,y+h)
	sprite("img").rect = r
end

----------------------------------------
--
----------------------------------------
--on mToggleKeepRatio
--  gOL["prefs"]["keep_ratio"] = not(gOL["prefs"]["keep_ratio"])
--
--  m = gOL["menu_obj"]
--  m.setItemCheckMark ("View", "Keep Aspect Ratio", gOL["prefs"]["keep_ratio"])
--
--  resizeWindow() -- update video rect
--end

----------------------------------------
--
----------------------------------------
on mFullscreen
	mToggleFullscreen()
end

----------------------------------------
--
----------------------------------------
on mPreviousImage
  types = []
 	cnt = count(gOL["formats"]["read"])
 	repeat with f in gOL["formats"]["read"]
 		repeat with t in f["types"]
 			types.add("."&t)
 		end repeat
 	end repeat
 	
  if ["","scan","clipboard"].getPos(gOL["filename"])=0 then
	  folderPath = getFolder(gOL["filename"])
	  fileList = getFiles(folderPath, types)
	  --put fileList
	  pos = fileList.getPos(getFile(gOL["filename"]))
	  if pos=0 then return
	  pos=pos-1
	  if pos<1 then pos=count(fileList)
	  gOL["IMAGE_MGR"].mOpenFile(folderPath & fileList[pos])
  end if
end

----------------------------------------
--
----------------------------------------
on mNextImage
  types = []
 	cnt = count(gOL["formats"]["read"])
 	repeat with f in gOL["formats"]["read"]
 		repeat with t in f["types"]
 			types.add("."&t)
 		end repeat
 	end repeat
 	
  if ["","scan","clipboard"].getPos(gOL["filename"])=0 then
	  folderPath = getFolder(gOL["filename"])
	  fileList = getFiles(folderPath, types)
	  --put fileList
	  pos = fileList.getPos(getFile(gOL["filename"]))
	  if pos=0 then return
	  pos=pos+1
	  if pos>count(fileList) then pos=1
	  gOL["IMAGE_MGR"].mOpenFile(folderPath & fileList[pos])
  end if
end

----------------------------------------
--
----------------------------------------
on mPreviousPage
  alert("TO DO")
end

----------------------------------------
--
----------------------------------------
on mNextPage
  alert("TO DO")
end

----------------------------------------
--
----------------------------------------
on mExportPage
  alert("TO DO")
end

--**************************************
-- HELP
--**************************************

----------------------------------------
--
----------------------------------------
on mAbout
  alert("ImgViewer v"&gOL["options"]["version"] & RETURN&RETURN&" Valentin Schmidt")
end
