-- Radio button behavior
property pS, pM
property pValue      -- Value of radion button
property pGroupName  -- Group radio button belongs to
property pChecked    -- Whether button is checked by default

on beginSprite me
  pS = sprite(me.spriteNum)
  pM = pS.member
  
  -- If the radio button is defined as the default selection in
  -- the set, hilite it and turn off any other buttons in the group.
  if me.pChecked then
    sendAllSprites(#resetRadioButtonsFalse, me.pGroupName)
    pM.hilite = TRUE
  else
    pM.hilite = FALSE
  end if
end

on endSprite me
  pM.hilite = FALSE
end

on resetRadioButtonsFalse me, buttonGroup, sender
  -- Escape the call if made by same object
  if sender = me then return
  
  -- Turn off button hilighting if part of the group being called
  if buttonGroup = me.pGroupName then
    pM.hilite = FALSE
  end if
end

on mouseUp me
  -- Turn off all other button hilighting and enable the hilite
  -- of the clicked button
  sendAllSprites(#resetRadioButtonsFalse, me.pGroupName, me)
  pM.hilite = TRUE
  
  sendSprite("histo", #channelChanged, pValue)
end

on getFormData me, data
  if pM.hilite then
    data[pGroupName] = pValue
  end if
end

on getPropertyDescriptionList me
  pl = [:]
  pl[#pGroupName] = [#comment: "Group-Name", #format:  #string, #default: ""]
  pl[#pValue] = [#comment: "Button-Value", #format: #string, #default: ""]
  pl[#pChecked] = [#comment: "Checked?", #format: #boolean, #default: FALSE]
  return pl
end